// cairo test program by Frank Buss (aka Shine)

#include <pspkernel.h>
#include <pspdebug.h>
#include <pspge.h>
#include <pspdisplay.h>
#include <pspctrl.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <cairo.h>

/* Define the module info section */
PSP_MODULE_INFO("CAIROTEST", 0, 1, 1);

/* Define the main thread's attribute value (optional) */
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

/* Exit callback */
int exit_callback(void)
{
	sceKernelExitGame();

	return 0;
}

/* Callback thread */
int CallbackThread(SceSize args, void *argp)
{
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", (void *) exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);

	sceKernelSleepThreadCB();

	return 0;
}

/* Sets up the callback thread and returns its thread id */
int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
	if(thid >= 0)
	{
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
}

int main(int argc, char** argv)
{
	pspDebugScreenInit();
	SetupCallbacks();

	while (1) {




  cairo_surface_t *surface;
        void* vram = (void *) (0x40000000 | (u32) sceGeEdramGetAddr());
        surface = cairo_image_surface_create_for_data (vram, CAIRO_FORMAT_ARGB32, 480, 272, 512*4);
                                             
        cairo_t *cr;
        cr = cairo_create (surface);

cairo_pattern_t* pat = cairo_pattern_create_linear (0.0, 0.0,  0.0, 1.0);
cairo_pattern_add_color_stop_rgba (pat, 1, 0, 0, 0, 1);
cairo_pattern_add_color_stop_rgba (pat, 0, 1, 1, 1, 1);
cairo_rectangle (cr, 0, 0, 1, 1);
cairo_set_source (cr, pat);
cairo_fill (cr);
cairo_pattern_destroy (pat);

pat = cairo_pattern_create_radial (0.45, 0.4, 0.1,
                                   0.4,  0.4, 0.5);
cairo_pattern_add_color_stop_rgba (pat, 0, 1, 1, 1, 1);
cairo_pattern_add_color_stop_rgba (pat, 1, 0, 0, 0, 1);
cairo_set_source (cr, pat);
cairo_arc (cr, 0.5, 0.5, 0.3, 0, 2 * M_PI);
cairo_fill (cr);
cairo_pattern_destroy (pat);




		SceCtrlData pad;
		sceCtrlReadBufferPositive(&pad, 1); 
		if (pad.Buttons & PSP_CTRL_CROSS) break;
		sceDisplayWaitVblankStart();
	}

	sceKernelExitGame();

	return 0;
}
